
--------------------  Basic Setup  ------------------------------------------

	Druidcom = AceLibrary("AceAddon-2.0"):new(	"AceConsole-2.0",
												"AceDB-2.0",
												"AceEvent-2.0",
												"AceDebug-2.0",
												"AceComm-2.0",
												"AceHook-2.0",
												"Metrognome-2.0")
	Druidcom:RegisterDB("DruidcomDB")
	local defaultsTable={
				hidden = false,
    			Innervate_Classes = {	["PRIEST"] = true,
										["DRUID"] = true,
										["MAGE"] = true,
										["PALADIN"] = true,
										["SHAMAN"] = true,
										["HUNTER"] = true,
										["WARLOCK"] = true},
    			Rebirth_Classes = {	["WARRIOR"] = true,
									["DRUID"] = true,
									["PRIEST"] = true,
									["MAGE"] = true,
									["PALADIN"] = true,
									["SHAMAN"] = true,
									["HUNTER"] = true,
									["ROGUE"] = true,
									["WARLOCK"] = true},
    			Mana_Threshold = 0.2,
    			xPos = 300,
    			yPos= 300,
	   			minimized = true,
	   			refreshTime = 0
	}
	Druidcom:RegisterDefaults("profile", defaultsTable)

	Druidcom:SetCommPrefix("Druidcom")
	Druidcom:RegisterMemoizations {"innervate", "rebirth", "refresh"}
----------------------  Locals  -----------------------------------------------
   	local L 		= AceLibrary("AceLocale-2.1"):GetInstance("Druidcom", true)
	local roster	= AceLibrary("RosterLib-2.0")
	local dewdrop 	= AceLibrary("Dewdrop-2.0")
	local crayon	= AceLibrary("Crayon-2.0")
	local druids = {}
	local Popup = {}
    local PeopleInCharge = {}
    local DC_Innervate_Index
    local DC_Rebirth_Index
	-- This will contain the spell that is waiting to be targeted
	local Druidcom_Spell
	-- This will contain the spell that has been cast and targeted and is awaiting a SPELLCAST_STOP
	local Druidcom_EndCast
	-- This contains the target of the current spell being casting
	local Druidcom_Target
	local DC_EXPIRETIME = 20
   	local InnervateCD, RebirthCD
    local COLOR = {
				["DRUID"] 	= {r = 1.00, 	g=0.49, 	b=0.04},
				["HUNTER"] 	= {r = 0.67, 	g=0.83, 	b=0.45},
				["MAGE"] 	= {r = 0.41, 	g=0.80, 	b=0.94},
				["PALADIN"]	= {r = 0.96, 	g=0.55, 	b=0.73},
				["PRIEST"] 	= {r = 1.00, 	g=1.00, 	b=1.00},
				["ROGUE"] 	= {r = 1.00, 	g=0.96, 	b=0.41},
				["SHAMAN"] 	= {r = 0.96, 	g=0.55, 	b=0.73},
				["WARLOCK"] = {r = 0.58, 	g=0.51, 	b=0.79},
				["WARRIOR"] = {r = 0.78, 	g=0.61, 	b=0.43},
				["REDFLASH"]= {r = 0.90,	g=0.10,		b=0.10,		a=0.7},
				["YELLOWFLASH"]= {r = 0.70,	g=0.70,		b=0.00,		a=0.7},
				["GREENFLASH"]= {r = 0.10,	g=0.90,		b=0.10,		a=0.7},
				["GREENHEX"] = "00FF00",
				["REDHEX"] = "FF0000",
				["YELLOWHEX"] = "FFFF00",
				["BLUEHEX"] = "0000FF",
				["GRAYHEX"] = "888888",
    		}
	local OptionsTable={
		type="group",
		name="Druidcom",
		args= {
			Innervate_Classes ={
				type="group",
				name=L["Innervate Classes"],
				desc=L["Which classes should be shown in the innervate menu?"],
				args = {
					druid = {
						type="toggle",
						name=L["DRUID"],
						desc=L["Show Druids"],
						get = function() return Druidcom.db.profile.Innervate_Classes["DRUID"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["DRUID"] = value end
					},
					priest = {
						type="toggle",
						name=L["PRIEST"],
						desc=L["Show Priests"],
						get = function() return Druidcom.db.profile.Innervate_Classes["PRIEST"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["PRIEST"] = value end
					},
					mage = {
						type="toggle",
						name=L["MAGE"],
						desc=L["Show Mages"],
						get = function() return Druidcom.db.profile.Innervate_Classes["MAGE"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["MAGE"] = value end
					},
					paladin = {
						type="toggle",
						name=L["PALADIN"],
						desc=L["Show Paladins"],
						get = function() return Druidcom.db.profile.Innervate_Classes["PALADIN"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["PALADIN"] = value end
					},
					shaman = {
						type="toggle",
						name=L["SHAMAN"],
						desc=L["Show Shamans"],
						get = function() return Druidcom.db.profile.Innervate_Classes["SHAMAN"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["SHAMAN"] = value end
					},
					hunter = {
						type="toggle",
						name=L["HUNTER"],
						desc=L["Show Hunters"],
						get = function() return Druidcom.db.profile.Innervate_Classes["HUNTER"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["HUNTER"] = value end
					},
					warlock = {
						type="toggle",
						name=L["WARLOCK"],
						desc=L["Show Warlocks"],
						get = function() return Druidcom.db.profile.Innervate_Classes["WARLOCK"] end,
						set = function(value) Druidcom.db.profile.Innervate_Classes["WARLOCK"] = value end
					}
				},
				guiHidden = false,
				cmdHidden = true
			},

			Rebirth_Classes ={
				type="group",
				name=L["Rebirth Classes"],
				desc=L["Which classes should be shown in the rebirth menu?"],
				args = {
					warrior = {
						type="toggle",
						name=L["WARRIOR"],
						desc=L["Show Warriors"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["WARRIOR"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["WARRIOR"] = value end
					},
					druid = {
						type="toggle",
						name=L["DRUID"],
						desc=L["Show Druids"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["DRUID"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["DRUID"] = value end
					},
					priest = {
						type="toggle",
						name=L["PRIEST"],
						desc=L["Show Priests"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["PRIEST"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["PRIEST"] = value end
					},
					mage = {
						type="toggle",
						name=L["MAGE"],
						desc=L["Show Mages"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["MAGE"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["MAGE"] = value end
					},
					paladin = {
						type="toggle",
						name=L["PALADIN"],
						desc=L["Show Paladins"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["PALADIN"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["PALADIN"] = value end
					},
					shaman = {
						type="toggle",
						name=L["SHAMAN"],
						desc=L["Show Shamans"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["SHAMAN"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["SHAMAN"] = value end
					},
					rogue = {
						type="toggle",
						name=L["ROGUE"],
						desc=L["Show Rogues"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["ROGUE"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["ROGUE"] = value end
					},
					hunter = {
						type="toggle",
						name=L["HUNTER"],
						desc=L["Show Hunters"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["HUNTER"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["HUNTER"] = value end
					},
					warlock = {
						type="toggle",
						name=L["WARLOCK"],
						desc=L["Show Warlocks"],
						get = function() return Druidcom.db.profile.Rebirth_Classes["WARLOCK"] end,
						set = function(value) Druidcom.db.profile.Rebirth_Classes["WARLOCK"] = value end
					}
				},
				guiHidden = false,
				cmdHidden = true
			},

			toggle ={
				type="toggle",
				name=L["toggle"],
				desc=L["Toggle the Druidcom window"],
	
				get = function()
					return Druidcom.db.profile.hidden
				end,
				
				set = function()
					Druidcom.db.profile.hidden = not Druidcom.db.profile.hidden
					if(Druidcom.db.profile.hidden) then
						getglobal("DruidcomTitleFrame"):Hide()
					else
--						Druidcom:BuildInterface()
						getglobal("DruidcomTitleFrame"):Show()
					end
				end,
				map = { [false] = L["show"], [true] = L["hide"] },
				guiHidden = true,
				cmdHidden = false
			},

   			reset ={
				type="execute",
				name=L["reset"],
				desc=L["Reset Druidcom's Position"],

				func = function()
					Druidcom.db.profile.xPos = 300
					Druidcom.db.profile.yPos = 300
					getglobal("DruidcomTitleFrame"):SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT",-- and attach it to the screen
					                                  300,-- with the saved coordinates
					                                  300)
					
				end,
			},

			Mana_Threshold = {
				type="range",
				name=L["Mana Threshold"],
				desc=L["Raid Members with mana above this threshold will not be shown in the innervate menu"],
				step=0.01,
				isPercent = true,

				get = function()
					return Druidcom.db.profile.Mana_Threshold
				end,

				set = function(value)
					Druidcom.db.profile.Mana_Threshold = value
				end,
				
				validate= function(value)
					value = tonumber(value)
					if(value and value>0) then
						return TRUE
					else
						return FALSE
					end
				end
			},
			refreshTime = {
				type="range",
				name=L["Refresh Time"],
				desc=L["How many seconds between automatic updates? (0 for no automatic updates, applies only to leader or promoted)"],
				min=0,
				max=60,
				step=5,
				get = function()
					return Druidcom.db.profile.refreshTime
				end,

				set = "SetRefreshTime",
				
				validate= function(value)
					value = tonumber(value)
					if(value and value>0) then
						return TRUE
					else
						return FALSE
					end
				end
			}

		}
	}
Druidcom:RegisterChatCommand({"/druidcom", "/dc"}, OptionsTable)


----------------------  Ace Function Handlers  -----------------------------------------------

    function Druidcom:OnInitialize()
		self:RegisterChatCommand({"/druidcom", "/dc"}, OptionsTable)
	    self:RegisterMetro("DC_UpdateTimer", self.RequestUpdate, 10, self)
	    self:RegisterMetro("DC_TickTimer", self.UpdateTimers, 1, self)
	    StaticPopupDialogs["INNERVATE"] = {
					  text = L["%s would like you to innervate %s"],
					  button1 = TEXT(L["Do it!"]),
					  button2 = TEXT(L["Not now!"]),
					  OnAccept = function(target)
						local currentTarget = UnitName("target")
						TargetByName(target, true)
						CastSpell(DC_Innervate_Index, BOOKTYPE_SPELL)
						if(currentTarget) then
							TargetByName(currentTarget, true)
						end
					  end,
					  OnCancel = function()
					      Druidcom:SendCommMessage("GROUP",false, false, "innervate")
					      Druidcom:SendCommMessage("WHISPER",UnitName("player"), false, false, "innervate")
					  end,
					  timeout = 20,
					  whileDead = 0,
					  hideOnEscape = 1}

		StaticPopupDialogs["REBIRTH"] = {
					  text = L["%s would like you to resurrect %s"],
					  button1 = TEXT(L["Do it!"]),
					  button2 = TEXT(L["Not now!"]),
					  OnAccept = function(target)
						local currentTarget = UnitName("target")
						TargetByName(target, true)
						CastSpell(DC_Rebirth_Index, BOOKTYPE_SPELL)
						if(currentTarget) then
							TargetByName(currentTarget, true)
						end
					  end,
					  OnCancel = function()
					      Druidcom:SendCommMessage("GROUP",false , false, "rebirth")
					      Druidcom:SendCommMessage("WHISPER",UnitName("player"), false, false, "rebirth")
					  end,
					  timeout = 20,
					  whileDead = 0,
					  hideOnEscape = 1
					}
    end

    function Druidcom:OnEnable()
    	self:SetDebugging(false)
		getglobal("DruidcomTitleFrame"):SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT",-- and attach it to the screen
		                                  self.db.profile.xPos,-- with the saved coordinates
		                                  self.db.profile.yPos)
		if(self.db.profile.hidden) then
        	getglobal("DruidcomTitleFrame"):Hide()
    	elseif(self.db.profile.minimized) then
        	getglobal("DruidcomFrame"):Hide()
        else
        	getglobal("DruidcomFrame"):Show()
        end

		self:RegisterEvent("RosterLib_RosterChanged")
		self:RegisterEvent("RosterLib_PendingRefresh")
		self:RegisterEvent("SPELLCAST_FAILED");
		self:RegisterEvent("SPELLCAST_STOP");
		self:RegisterEvent("SPELLCAST_INTERRUPTED");
		self:RegisterDrops()
    	roster:Enable()
    	self:FindSpells()
		self:RegisterComm(self.commPrefix, "GROUP", "ReceiveMessage")
		self:RegisterComm(self.commPrefix, "WHISPER", "ReceiveMessage")
		self:StartMetro("DC_TickTimer");
    	if(self:IsInCharge(UnitName("player"))) then
    		self:StartMetro("DC_UpdateTimer")
		end
		self:BuildInterface()
		
		self:Hook("CastSpell")
		self:Hook("CastSpellByName")
		self:Hook("UseAction")
		self:Hook("SpellTargetUnit")
		self:Hook("TargetUnit")
		self:Hook("SpellStopTargeting")
		self:HookScript(WorldFrame, "OnMouseDown")

    end

    function Druidcom:OnDisable()
    	roster:Disable()
    end

----------------------  Hooks  and Events -----------------------------------------------
	function Druidcom:SPELLCAST_FAILED()
	   if Druidcom_EndCast then
	       Druidcom_EndCast = nil
	       Druidcom_Target = nil
	       Druidcom_Spell = nil
	   end
	end

	function Druidcom:SPELLCAST_INTERRUPTED()
	   if Druidcom_EndCast then
	       Druidcom_EndCast = nil
	       Druidcom_Target = nil
	       Druidcom_Spell = nil
	   end
	end

	function Druidcom:SPELLCAST_STOP()
--		self:Debug("Test")
	   if Druidcom_EndCast then
	   		self:Debug("Druidcom_EndCast = ", Druidcom_EndCast, "   Druidcom_Target = ", Druidcom_Target, "   Druidcom_Spell = ", Druidcom_Spell)
	   		if(Druidcom_EndCast == L["Innervate"]) then
				self:SendMessage(false , false, "innervate", false, Druidcom_Target)
				self:SendUpdate()
			elseif(Druidcom_EndCast == L["Rebirth"]) then
				self:SendMessage(false , false, "rebirth", false, Druidcom_Target)
				self:SendUpdate()
	   		end
	       Druidcom_EndCast = nil
	       Druidcom_Target = nil
	       Druidcom_Spell = nil
	   end
	end

	function Druidcom:OnMouseDown()
		self.hooks[WorldFrame].OnMouseDown.orig()
	   if arg1 == "LeftButton" then
	       local targetName;

	       if Druidcom_Spell and UnitExists("mouseover") then
	           targetName = UnitName("mouseover")
	       end

	       if Druidcom_Spell and targetName then
	           Druidcom_EndCast = Druidcom_Spell
	           Druidcom_Target = targetName
	           Druidcom_Spell = nil
	       end
	   end
	end

	function Druidcom:SpellStopTargeting()
	   self.hooks.SpellStopTargeting.orig()

	   if Druidcom_Spell then
	       Druidcom_Spell = nil
	       Druidcom_EndCast = nil
	       Druidcom_Target = nil
	   end
	end

	function Druidcom:TargetUnit(unit)
	   -- Call the original function
	   self.hooks.TargetUnit.orig(unit)

	   -- Look to see if we're currently waiting for a target internally
	   -- If we are, then well glean the target info here.
	   
	   if Druidcom_Spell then
	       -- Currently casting.. lets grab the target
	       Druidcom_EndCast = Druidcom_Spell
	       Druidcom_Target = UnitName(unit)
	       
	       -- Clear MyMod_Spell so we can wait for SPELLCAST_STOP
	       Druidcom_Spell = nil
	   end
	end

	function Druidcom:SpellTargetUnit(unit)
	   -- Call the original function
	   self.hooks.SpellTargetUnit.orig(unit)

	   -- Look to see if we're currently waiting for a target internally
	   -- If we are, then well glean the target info here.

	   if Druidcom_Spell then
	       -- Currently casting.. lets grab the target
	       Druidcom_EndCast = Druidcom_Spell
	       Druidcom_Target = UnitName(unit)

	       -- Clear MyMod_Spell so we can wait for SPELLCAST_STOP
	       Druidcom_Spell = nil
	   end
	end

	function Druidcom:CastSpell(spellId, spellbookTabNum)
	   -- Call the original function so there's no delay while we process
		self.hooks.CastSpell.orig(spellId, spellbookTabNum)
	   -- Load the tooltip with the spell information
	   Druidcom_Tooltip:SetSpell(spellId, spellbookTabNum)
	   
	   local spellName = Druidcom_TooltipTextLeft1:GetText()
	       
	   if SpellIsTargeting() then 
	       -- Spell is waiting for a target
	       Druidcom_Spell = spellName
	   else
	       -- Spell is being cast on the current target.  
	       -- If ClearTarget() had been called, we'd be waiting target
	       Druidcom_EndCast = spellName
	       Druidcom_Target = UnitName("target")
	   end
	end
	
	function Druidcom:CastSpellByName(spellName, onSelf)
	   -- Call the original function
	   self.hooks.CastSpellByName.orig(spellName, onSelf)

	   -- This will give us the full spellname, including Rank.
	   -- This can be filtered out quite easily
	   local spellName = spellName

	   if SpellIsTargeting() then
	       -- Spell is waiting for a target
	       Druidcom_Spell = spellName
	   else
	       -- Spell is being cast on the current target
	       Druidcom_EndCast = spellName
	       if onSelf then
	           Druidcom_Target = UnitName("player")
	       else
	           Druidcom_Target = UnitName("target")
	       end
	   end
	end
	
	function Druidcom:UseAction(a1, a2, a3)
	   -- Call the original function
	   self.hooks.UseAction.orig(a1, a2, a3)
	   
	   -- Test to see if this is a macro
	   if GetActionText(a1) then return end
	   
	   Druidcom_Tooltip:SetAction(a1)
	   local spellName = Druidcom_TooltipTextLeft1:GetText()
	   
	   if SpellIsTargeting() then
	       -- Spell is waiting for a target
	       Druidcom_Spell = spellName
	   else
	       -- Spell is being cast on the current target
	       Druidcom_EndCast = spellName
	       Druidcom_Target = UnitName("target")
	   end
	
	end

----------------------  Utility  -----------------------------------------------

	function Druidcom:InnervateTargetExpired(druid)
		druids[druid].InnervateTarget = nil

	end

	function Druidcom:RebirthTargetExpired(druid)
		druids[druid].RebirthTarget = nil
	end

    function Druidcom:RosterLib_RosterChanged(tbl)
    	local RebuildNecessary = FALSE
    	PeopleInCharge = {}
		for n, unit in pairs(tbl) do
			if(unit.class and unit.class == "DRUID") then
				if(not unit.name) then
					druids[unit.oldname]= nil
					RebuildNecessary = true
				elseif(not unit.oldname) then
					druids[unit.name] = {}
					RebuildNecessary = true
				end
			end
	
			if(unit.rank and unit.rank > 0) then
				table.insert(PeopleInCharge, unit.name)
			end

			if(unit.oldrank ~= unit.rank and unit.unitid == "player") then
				if(unit.rank == 0) then
					getglobal("DCRefreshButton"):Hide()
				else
					getglobal("DCRefreshButton"):Show()
				end
			end
		end

		local player = roster:GetUnitObjectFromName(UnitName("player"))
		if(player.rank ~= player.oldrank) then
			RebuildNecessary = true
		end
	
		if(RebuildNecessary) then
			self:BuildInterface()
		end
	end
	
    function Druidcom:IsInCharge(playername)
    	for _, boss in PeopleInCharge do
    		if(boss == playername) then
    			return true
    		end
    	end
    end

	function Druidcom:FindSpells()
		local spellName
		local i= 1
		repeat
			spellName= GetSpellName(i, BOOKTYPE_SPELL)
			if(spellName == L["Innervate"]) then
            	DC_Innervate_Index = i
            elseif(spellName == L["Rebirth"]) then
				DC_Rebirth_Index = i
			end
			i=i+1
	    until not spellName
	end
	
	function Druidcom:RosterLib_PendingRefresh()
	end

----------------------  Interface  -----------------------------------------------
	function Druidcom:SetRefreshTime(value)
		if(self.db.profile.refreshTime == 0 and value ~=0) then
			self:ChangeMetroRate("DC_UpdateTimer", value)
			if(self:IsInCharge(UnitName("player"))) then
				self:StartMetro("DC_UpdateTimer")
			end
		elseif(self.db.profile.refreshTime ~= 0 and value ~=0) then
			self:ChangeMetroRate("DC_UpdateTimer", value)
		else
			self:StopMetro("DC_UpdateTimer")
		end
		self.db.profile.refreshTime = value
	end

	function Druidcom:RegisterDrops()
		for i=1,10 do
			dewdrop:Register(	getglobal("Druidcom"..i.."InnervateButton"),
								'children', function(level, value) Druidcom:InnervateDrop(level, value) end
			)
			dewdrop:Register(	getglobal("Druidcom"..i.."RebirthButton"),
								'children', function(level, value) Druidcom:RebirthDrop(level, value) end
			)
		end
		dewdrop:Register(	getglobal("DruidcomTitleFrame"),
							'children', function()
								dewdrop:FeedAceOptionsTable(OptionsTable)
							end)
	end


	function Druidcom:SaveWindowPos(name)
	   self.db.profile.xPos = getglobal(name):GetLeft()
	   self.db.profile.yPos = getglobal(name):GetTop()
	end

	
	function Druidcom:ToggleMinimize()
-- 		if(self:IsDebugging()) then
-- 			druids["Eol"] = {}
-- 			druids["Eol"].InnervateCD = 0
-- 			druids["Eol"].RebirthCD = 60
-- 			self:BuildInterface()
--     				r = COLOR["GREENFLASH"].r
--     				g = COLOR["GREENFLASH"].g
--     				b = COLOR["GREENFLASH"].b
--     				a = COLOR["GREENFLASH"].a
-- 
--    				local flashframe = getglobal("Druidcom1InnervateButtonFlashOverlayTexture")
--    				flashframe:SetTexture(r,g,b,a)
--    				if(UIFrameIsFading(flashframe:GetParent())) then
--    					UIFrameFlashRemoveFrame(flashframe:GetParent())
--    					flashframe:GetParent():SetAlpha(0)
--    				end
--    				UIFrameFlash(flashframe:GetParent(), 1, 1, 6, false, 0, 0)
-- 		end
		if(self.db.profile.minimized) then
			getglobal("DruidcomFrame"):Show()
			getglobal("DCRefreshButton"):Show()
			self.db.profile.minimized = false
		else
			getglobal("DruidcomFrame"):Hide()
			getglobal("DCRefreshButton"):Hide()
			self.db.profile.minimized = true
		end
	end


	function Druidcom:BuildInterface()
		for i=1,10 do
			getglobal("Druidcom"..i):Hide()
		end
		local i=0
 		for druid, table in pairs(druids) do
			i=i+1
			getglobal("Druidcom"..i):Show()
 		end
 		if(i==0) then
			getglobal("DruidcomFrame"):Hide()
			self:Print(L["No Druids found in raid, Druidcom minimized."])
		else
	 		getglobal("DruidcomFrame"):SetHeight(35*i+10)
	 		getglobal("DruidcomFrame"):Show()
	 		self:UpdateInterface()
	 		self:UpdateTimers()
	 	end
	end

    function Druidcom:UpdateInterface()
    	local i=1
    	for druid, table in pairs(druids) do
--     		if(self:IsDebugging()) then
--     			unit = {}
--     			unit.name="Eol"
--     			unit.unitid="player"
--     			unit.subgroup = 1
--     		else
	    	local unit = roster:GetUnitObjectFromName(druid)
--	    	end
    		-- set up text for group and name
    		if(unit) then
	    		local fontstring = getglobal("Druidcom"..i.."Name")
				fontstring:SetText(unit.subgroup.."-"..unit.name)
	    		if(not UnitIsConnected(unit.unitid)) then
					fontstring:SetTextColor(0.5, 0.5, 0.5) --gray if offline
	    		elseif(not druids[druid].InnervateCD) then
					fontstring:SetTextColor(0, 0, 1.0) -- blue if no Druidcom found
				elseif(UnitIsDeadOrGhost(unit.unitid)) then
					fontstring:SetTextColor(1.0, 0, 0) -- red if dead
				elseif(not UnitIsVisible(unit.unitid)) then
					fontstring:SetTextColor(1.0, 1.0, 0) -- yellow if out of range
				else
					fontstring:SetTextColor(0, 1.0, 0) -- green if everything is ok
				end
				i=i+1
			end
		end
    end

    function Druidcom:UpdateTimers()
    	local i=1
    	for druid, table in pairs(druids) do
    		if(druids[druid].InnervateCD) then
				if(druids[druid].InnervateCD > 0) then
					druids[druid].InnervateCD = druids[druid].InnervateCD - 1
					getglobal("Druidcom"..i.."InnervateButtonNormalTexture"):SetVertexColor(0.3, 0.3, 0.3)
					local label = getglobal("Druidcom"..i.."InnervateButton_Label")
					local InnervateCD= druids[druid].InnervateCD
					if(InnervateCD <= 60) then
						local v = InnervateCD / 60
						label:SetTextColor(1.0, v, v)
						label:SetText(string.format("%d", InnervateCD))
					else
						label:SetTextColor(1.0, 1.0, 1.0)
						label:SetText(string.format("%d", math.floor(InnervateCD/60 +0.5)))
					end
				else
					getglobal("Druidcom"..i.."InnervateButtonNormalTexture"):SetVertexColor(1.0, 1.0, 1.0)
					getglobal("Druidcom"..i.."InnervateButton_Label"):SetText("")
				end
			else
				getglobal("Druidcom"..i.."InnervateButtonNormalTexture"):SetVertexColor(0.3, 0.3, 0.3)
				getglobal("Druidcom"..i.."InnervateButton_Label"):SetText("?")
			end

			if(druids[druid].RebirthCD) then
				if(druids[druid].RebirthCD > 0) then
					druids[druid].RebirthCD = druids[druid].RebirthCD -1
					getglobal("Druidcom"..i.."RebirthButtonNormalTexture"):SetVertexColor(0.3, 0.3, 0.3)
					local label = getglobal("Druidcom"..i.."RebirthButton_Label")
					local RebirthCD= druids[druid].RebirthCD
					if(RebirthCD <= 60) then
						local v = RebirthCD / 60
						label:SetTextColor(1.0, v, v)
						label:SetText(string.format("%d", RebirthCD))
					else
						label:SetTextColor(1.0, 1.0, 1.0)
						label:SetText(string.format("%d", math.floor(RebirthCD/60 +0.5)))
					end
				else
					getglobal("Druidcom"..i.."RebirthButtonNormalTexture"):SetVertexColor(1.0, 1.0, 1.0)
					getglobal("Druidcom"..i.."RebirthButton_Label"):SetText("")
				end
			else
				getglobal("Druidcom"..i.."RebirthButtonNormalTexture"):SetVertexColor(0.3, 0.3, 0.3)
				getglobal("Druidcom"..i.."RebirthButton_Label"):SetText("?")
			end
			i=i+1
    	end
    end
    
    function Druidcom:InnervateDrop(level, value)
    	if(not dewdrop:GetOpenedParent()) then return end
	    local recipient = string.sub(getglobal(dewdrop:GetOpenedParent():GetParent():GetName().."Name"):GetText(),3)
    	if(druids[recipient].InnervateCD and druids[recipient].InnervateCD > 0 or not druids[recipient].InnervateCD) then return end
    	if(self:IsInCharge(UnitName("player"))) then
	    	if(level == 1) then
				dewdrop:AddLine(	'text', L["Innervate"],
									'isTitle', true)
				for class, on in pairs(self.db.profile.Innervate_Classes) do
					if(on) then
						dewdrop:AddLine(	"text", L[class],
											"textR", COLOR[class].r,
											"textG", COLOR[class].g,
											"textB", COLOR[class].b,
											"hasArrow", true,
											"value", class)
					end
				end
			elseif(level == 2) then
				for unit in roster:IterateRoster() do
					if (unit.class == value and self.db.profile.Innervate_Classes[value] and
						UnitMana(unit.unitid)/UnitManaMax(unit.unitid) <= self.db.profile.Mana_Threshold) then
						dewdrop:AddLine(	"text", unit.name,
											"textR", COLOR[value].r,
											"textG", COLOR[value].g,
											"textB", COLOR[value].b,
											"func", function(target, recipient) Druidcom:SendInnervateRequest(target, recipient) end,
											"arg1", unit.name,
											"arg2", recipient
						)
					end
				end
			end
		end
    end

	function Druidcom:RebirthDrop(level, value)
    	if(not dewdrop:GetOpenedParent()) then return end
	    local recipient = string.sub(getglobal(dewdrop:GetOpenedParent():GetParent():GetName().."Name"):GetText(),3)
    	if(druids[recipient].RebirthCD and druids[recipient].RebirthCD > 0 or not druids[recipient].RebirthCD) then return end
    	if(self:IsInCharge(UnitName("player"))) then
	    	if(level == 1) then
				dewdrop:AddLine(	'text', L["Rebirth"],
									'isTitle', true)
				for class, on in pairs(self.db.profile.Rebirth_Classes) do
					if(on) then
						dewdrop:AddLine(	"text", L[class],
											"textR", COLOR[class].r,
											"textG", COLOR[class].g,
											"textB", COLOR[class].b,
											"hasArrow", true,
											"value", class)
					end
				end
			elseif(level == 2) then
				for unit in roster:IterateRoster() do
					if (unit.class == value and self.db.profile.Innervate_Classes[value] and UnitIsDeadOrGhost(unit.unitid)) then
						dewdrop:AddLine(	"text", unit.name,
											"textR", COLOR[value].r,
											"textG", COLOR[value].g,
											"textB", COLOR[value].b,
											"func", function(target, recipient) Druidcom:SendRebirthRequest(target, recipient) end,
											"arg1", unit.name,
											"arg2", recipient
						)
					end
				end
			end
		end
    end
    
    function Druidcom:InnervateFlash(druidCasted, target)
    	local i=1
    	for druid, table in pairs(druids) do
    		local unit = roster:GetUnitObjectFromName(druid)
    		if(unit.name == druidCasted) then
		    	local r, g, b, a
		    	self:Debug("Target: ", target)
		    	self:Debug("InnervateTarget: ", unit.InnervateTarget)
    			if(not target) then
    				self:Debug("1")
    				r = COLOR["REDFLASH"].r
    				g = COLOR["REDFLASH"].g
    				b = COLOR["REDFLASH"].b
    				a = COLOR["REDFLASH"].a
    			elseif(unit.InnervateTarget == target) then
    				self:Debug("2")
    				r = COLOR["GREENFLASH"].r
    				g = COLOR["GREENFLASH"].g
    				b = COLOR["GREENFLASH"].b
    				a = COLOR["GREENFLASH"].a
    			else
    				self:Debug("3")
    				r = COLOR["YELLOWFLASH"].r
    				g = COLOR["YELLOWFLASH"].g
    				b = COLOR["YELLOWFLASH"].b
    				a = COLOR["YELLOWFLASH"].a
    			end
	   			local flashframe = getglobal("Druidcom"..i.."InnervateButtonFlashOverlayTexture")
	   			flashframe:SetTexture(r,g,b,a)
	   			flashframe = getglobal("Druidcom"..i.."InnervateButtonFlashOverlay")
   				if(UIFrameIsFading(flashframe)) then
   					UIFrameFlashRemoveFrame(flashframe)
   					flashframe:SetAlpha(0)
   				end
   				UIFrameFlash(flashframe, 1, 1, 6, false, 0, 0)
    		end
    		i=i+1
    	end
    end

	function Druidcom:RebirthFlash(druidCasted, target)
    	local i=1
    	for druid, table in pairs(druids) do
			local unit = roster:GetUnitObjectFromName(druid)
	    	local r, g, b, a
    		if(unit.name == druidCasted) then
    			if(not target) then
    				r = COLOR["REDFLASH"].r
    				g = COLOR["REDFLASH"].g
    				b = COLOR["REDFLASH"].b
    				a = COLOR["REDFLASH"].a
    			elseif(unit.RebirthTarget == target) then
    				r = COLOR["GREENFLASH"].r
    				g = COLOR["GREENFLASH"].g
    				b = COLOR["GREENFLASH"].b
    				a = COLOR["GREENFLASH"].a
    			else
    				r = COLOR["YELLOWFLASH"].r
    				g = COLOR["YELLOWFLASH"].g
    				b = COLOR["YELLOWFLASH"].b
    				a = COLOR["YELLOWFLASH"].a
    			end
	   			local flashframe = getglobal("Druidcom"..i.."RebirthButtonFlashOverlayTexture")
	   			flashframe:SetTexture(r,g,b,a)
	   			flashframe = getglobal("Druidcom"..i.."RebirthButtonFlashOverlay")
   				if(UIFrameIsFading(flashframe)) then
   					UIFrameFlashRemoveFrame(flashframe)
   					flashframe:SetAlpha(0)
   				end
   				UIFrameFlash(flashframe, 1, 1, 6, false, 0, 0)
    		end
    		i=i+1
    	end
    end
    
    function Druidcom:ShowNameLegend()
    	local tooltip = getglobal("GameTooltip") --getglobal("Druidcom_NameLegend")
		tooltip:SetOwner(UIParent, "ANCHOR_NONE");
		tooltip:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y);

    	tooltip:SetText("Name:\n"..
						crayon:Colorize(COLOR["GREENHEX"], L["Green: "])..crayon:White(L["Everything OK"]).."\n"..
						crayon:Colorize(COLOR["REDHEX"], L["Red: "])..crayon:White(L["Dead"]).."\n"..
						crayon:Colorize(COLOR["YELLOWHEX"], L["Yellow: "])..crayon:White(L["Out of range"]).."\n"..
						crayon:Colorize(COLOR["BLUEHEX"], L["Blue: "])..crayon:White(L["No Druidcom detected"]).."\n"..
						crayon:Colorize(COLOR["GRAYHEX"], L["Gray: "])..crayon:White(L["Offline"]).."\n"..
						"\n"..
						L["Button-Flashing: "].."\n"..
						crayon:Colorize(COLOR["GREENHEX"], L["Green: "])..crayon:White(L["Assigned target innervated/rezzed"]).."\n"..
						crayon:Colorize(COLOR["YELLOWHEX"], L["Gray: "])..crayon:White(L["Other target innervated/rezzed"]).."\n"..
						crayon:Colorize(COLOR["REDHEX"], L["Red: "])..crayon:White(L["Request declined/ignored"]))
    end

-------------------------  Communications  ------------------------------------------------------
	
	function Druidcom:SendMessage(innervateCD, rebirthCD, command, recipient, target)
    	self:SendCommMessage("GROUP", innervateCD, rebirthCD, command, recipient, target)
    	self:SendCommMessage("WHISPER", UnitName("player"), innervateCD, rebirthCD, command, recipient, target)
	end

	function Druidcom:RequestUpdate()
    	if(self:IsInCharge(UnitName("player"))) then
			self:SendMessage(false , false, "refresh")
			if(self.db.profile.refreshTime > 0) then
	       		self:StartMetro("DC_UpdateTimer")
	       	end
		end
	end


	function Druidcom:SendUpdate()
    	if(DC_Innervate_Index and DC_Rebirth_Index) then
    		--Get Innervate cooldown
    		local start, duration = GetSpellCooldown(DC_Innervate_Index, BOOKTYPE_SPELL)
    		if(start~=0) then
	    		InnervateCD = duration - ( GetTime() - start)
	    	else
	    		InnervateCD = 0
	    	end
			--Get Rebirth cooldown
    		local start, duration = GetSpellCooldown(DC_Rebirth_Index, BOOKTYPE_SPELL)
    		if(start ~=0) then
	    		RebirthCD = duration - ( GetTime() - start)
	    	else
	    		RebirthCD=0
	    	end
    	else
			InnervateCD = nil
			RebirthCD = nil
    	end
		self:SendMessage(InnervateCD, RebirthCD)
	end

    function Druidcom:ReceiveMessage(prefix, sender, distri, innervateCD, rebirthCD, command, recipient, target)
    	if(command and target and not recipient) then
	    	self:Debug(sender, " has cast ", command, " on ",target)
	    end
    	if(innervateCD and rebirthCD and druids[sender]) then
    		druids[sender].InnervateCD = innervateCD
    		druids[sender].RebirthCD = rebirthCD
    		self:UpdateInterface()
    	end

		if(command and recipient and self:IsInCharge(sender) and target) then
	    	if(command == "innervate") then
	    		self:Debug("innervate, target = ", target)
	    		druids[recipient].InnervateTarget = target
	    		if(not self:MetroStatus(recipient.."Innervate")) then
		    		self:RegisterMetro(recipient.."Innervate", self.InnervateTargetExpired, DC_EXPIRETIME, self, recipient)
		    	end
	    		self:StartMetro(recipient.."Innervate", 1)
	    		if(UnitName("player") == recipient) then
					self:InnervateRequest(sender, target)
				end
			end
	    	if(command == "rebirth") then
	    		druids[recipient].RebirthTarget = target
	    		if(not self:MetroStatus(recipient.."Rebirth")) then
		    		self:RegisterMetro(recipient.."Rebirth", self.RebirthTargetExpired, DC_EXPIRETIME, self, recipient)
		    	end
	    		self:StartMetro(recipient.."Rebirth", 1)
	    		if(UnitName("player") == recipient) then
					self:RebirthRequest(sender, target)
				end
			end
	    elseif(command and not recipient) then
	    	if(command == "refresh") then self:SendUpdate()	end
	    	if(command == "innervate") then	self:InnervateFlash(sender, target)	end
	    	if(command == "rebirth") then self:RebirthFlash(sender, target) end
	    end
    end

    function Druidcom:InnervateRequest(sender, target)
    	local dialog = StaticPopup_Show("INNERVATE", sender, target)
    	if(dialog) then
    		dialog.data=target
    	end
    end

    function Druidcom:RebirthRequest(sender, target)
    	local dialog = StaticPopup_Show("REBIRTH", sender, target)
    	if(dialog) then
    		dialog.data=target
    	end
    end

	function Druidcom:SendInnervateRequest(target, recipient)
		self:SendMessage( false , false, "innervate", recipient, target)
	end

    function Druidcom:SendRebirthRequest(target, recipient)
		self:SendMessage( false , false, "rebirth", recipient, target)
	end
